
/*****************************************************

Chip type               : ATmega328p (Attiny13)
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
           , 
    c   .

*****************************************************/

#define F_CPU 8000000L

#include <avr/pgmspace.h>

#include <stdlib.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sfr_defs.h>
#include <stdio.h>

#include <util/delay.h>

#define StartConvAdc() ADCSRA |= (1<<ADSC)
#define StopConvAdc()   ADCSRA &=~(_BV(ADSC))  

#define TCNT0_const 0
#define TCCR0_const 5

#define LED_ON   PORTB |=_BV(PB0)         // 
#define LED_OFF  PORTB &=~(_BV(PB0))      // 

char  l;
int k;

volatile unsigned int AdcBuf;               

	
// ++++*************************      ***************************++++
void initialization(void)

{
PORTB=0x02;
DDRB=0x01;

MCUCR = (0<<PUD);

 /*******************************                ******************/
 
 //. ,   ,  ,  . = FCPU/128
   
DIDR0=0x00;
ADMUX = (0<<REFS0)|(0<<ADLAR)|(1<<MUX1)|(0<<MUX0);
ADCSRA=(1<<ADEN)|(0<<ADSC)|(0<<ADATE)|(0<<ADIF)|(0<<ADIE)|(0<<ADPS2)|(1<<ADPS1)|(1<<ADPS0); 
ADCSRB&=0xF8; 

 /*******************************                 ******************/

                                        //  Phase correct PWM ,   
                                        // =F_CPU / *512
TCCR0A |=(1<<WGM00);                    //  Phase correct PWM,       255,     0
TCCR0A |=(1<<COM0A1) | (0<<COM0A0);     // 0  1-   TCNT0  OCROA  1  2- . ( -)
TCCR0A |=(1<<COM0B1) | (1<<COM0B0);     // 1  1-   TCNT0  OCROB  0  2- . ( -)
TCCR0B |= (1<<CS00);                    //  8    

}
    /*************************    *************************/

 void Key_kontr_1()
{
  ADMUX = (0<<REFS0)|(0<<ADLAR)|(1<<MUX1)|(1<<MUX0);           //   () .
   //_delay_ms(1);                                    

 
  StartConvAdc();                                               //  .
   
	  while (ADCSRA&(1 << ADSC));                               //     	 

{
}  
   AdcBuf=(ADC>>2);
  
     OCR0A = AdcBuf ; //   	 		
   	  
           //AdcBuf=0;     
}  

     /*************************    *************************/
void Key_kontr()

{
  ADMUX = (0<<REFS0)|(0<<ADLAR)|(1<<MUX1)|(0<<MUX0);
  // _delay_ms(1);                                            

   
  StartConvAdc();                                                 //  .

 
    while (ADCSRA&(1 << ADSC));                                   //    
 {
 }      
        AdcBuf = ADC;                                             //   
    
    if      (AdcBuf < 94)        l=6;	               //
    else if (AdcBuf < 105)        l=7;                //
    else if (AdcBuf < 116)         l=8;               //
    else if (AdcBuf < 132)          l=9;              //
    else if (AdcBuf < 147)           l=10;            //
    else if (AdcBuf < 158)            l=11;           //
    else if (AdcBuf < 170)      l=12;                 // 
	else if (AdcBuf < 193)       l=13;                // 
    else if (AdcBuf < 217)        l=14;               // 
    else if (AdcBuf < 230)         l=15;              //
    else if (AdcBuf < 243)          l=16;             //
	else if (AdcBuf < 273)           l=17;            // 
	else if (AdcBuf < 303)            l=18;           //
	else if (AdcBuf < 448)       l=19;                // 
    else if (AdcBuf < 594)        l=20;               //
	else if (AdcBuf < 662)         l=21;              //  
	else if (AdcBuf < 729)          l=22;             //
    else if (AdcBuf < 773)           l=23;            //
	else if (AdcBuf < 817)            l=24;           //
	else if (AdcBuf < 854)             l=25;          //  
	else if (AdcBuf < 890)         l=26;              //
    else if (AdcBuf < 905)          l=27;             //
	else if (AdcBuf < 920)            l=28;           //

                                                      //
    else                                   l=29;	  //		
		
		switch(l)	
	{
  
   
	case 6:   OCR0A =  250;   break;
    case 7:   OCR0A =  240;    break;
	case 8:   OCR0A =  223;   break;
	case 9:   OCR0A =  205;    break;
	case 10:  OCR0A =  192;   break;
	case 11:  OCR0A =  178;   break;		
	case 12:  OCR0A =  164;  break;
	case 13:  OCR0A =  150;   break;	
	case 14:  OCR0A =  136;  break;
	case 15:  OCR0A =  122;   break;		
	case 16:  OCR0A =  114;  break;
	case 17:  OCR0A =  105;   break;
	case 18:  OCR0A =   98;  break;
	case 19:  OCR0A =   90;   break;
	case 20:  OCR0A =   80;  break;
	case 21:  OCR0A =   70;   break;
	case 22:  OCR0A =   63;  break;
	case 23:  OCR0A =   55;   break;
	case 24:  OCR0A =   48;  break;
	case 25:  OCR0A =   40;   break;
	case 26:  OCR0A =   33;  break;
	case 27:  OCR0A =   25;   break;
	case 28:  OCR0A =   18;  break;
	case 29:  OCR0A =   10;   break;
			
	
	}   	  
 
    AdcBuf=0; 
    
 } 
  
/************    *******************/                
int main(void)
{
initialization();
             
             
while (1)                                  // 
{
 
 if (bit_is_clear(PINB, 1))  Key_kontr_1();

  else Key_kontr();             

}

}
